Lab_PPW_2017/urls.py
from django.conf.urls import url,include
from django.views.generic import RedirectView
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
import lab_10.urls as lab_10
import lab_2_addon.urls as lab_2_addon

urlpatterns = [
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-3/', include(lab_3,namespace='lab-3')),
    url(r'^lab-4/', include(lab_4,namespace='lab-4')),
    url(r'^lab-5/', include(lab_5,namespace='lab-5')),
    url(r'^lab-6/', include(lab_6,namespace='lab-6')),
    url(r'^lab-7/', include(lab_7,namespace='lab-7')),
    url(r'^lab-8/', include(lab_8,namespace='lab-8')),
    url(r'^lab-9/', include(lab_9,namespace='lab-9')),
    url(r'^lab-10/', include(lab_10,namespace='lab-10')),
    url(r'^lab-2-addon/', include(lab_2_addon,namespace='lab-2-addon')),
    url(r'^$', RedirectView.as_view(url='lab-10/', permanent=True)),
]

lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_7/urls.py
from django.conf.urls import url
from .views import index,add_friend,validate_npm,delete_friend,friend_list,get_friend_list,friend_information

urlpatterns = [
        url(r'^$', index, name='index'),
        url(r'^add-friend/$', add_friend, name='add-friend'),
        url(r'^validate-npm/$', validate_npm, name='validate-npm'),
        url(r'^friend-list/$', friend_list, name='friend-list'),
        url(r'^get-friend-list/$', get_friend_list, name='get-friend-list'),
        url(r'^friend-list/delete-friend/(?P<npm>[0-9]+)/$', delete_friend, name='delete-friend'),
        url(r'^friend-list/info/(?P<npm>[0-9]+)/$', friend_information, name='info'),
]

lab_9/urls.py
from django.conf.urls import url
from .views import index, profile, \
    add_session_drones, del_session_drones, clear_session_drones, \
    cookie_login, cookie_auth_login, cookie_profile, cookie_clear

# sol to challenge
from .views import add_session_item, del_session_item, clear_session_item
# /sol
from .custom_auth import auth_login, auth_logout

urlpatterns = [
    url(r'^$', index, name='index'),
    url(r'^profile/$', profile, name='profile'),

    # custom auth
    url(r'^custom_auth/login/$', auth_login, name='auth_login'),
    url(r'^custom_auth/logout/$', auth_logout, name='auth_logout'),

    #add/delete drones
    url(r'^add_session_drones/(?P<id>\d+)/$', add_session_drones, name='add_session_drones'),
    url(r'^del_session_drones/(?P<id>\d+)/$', del_session_drones, name='del_session_drones'),
    url(r'^clear_session_drones/$', clear_session_drones, name='clear_session_drones'),
   
    # cookie
    url(r'^cookie/login/$', cookie_login, name='cookie_login'),
    url(r'^cookie/auth_login/$', cookie_auth_login, name='cookie_auth_login'),
    url(r'^cookie/profile/$', cookie_profile, name='cookie_profile'),
    url(r'^cookie/clear/$', cookie_clear, name='cookie_clear'), #sekaligus logout dari cookie


    url(r'^add_session_item/(?P<key>\w+)/(?P<id>\d+)/$', add_session_item, name='add_session_item'),
    url(r'^del_session_item/(?P<key>\w+)/(?P<id>\d+)/$', del_session_item, name='del_session_item'),
    url(r'^clear_session_item/(?P<key>\w+)/$', clear_session_item, name='clear_session_item'),

]

lab_7/models.py
from django.db import models

class Friend(models.Model):
    friend_name = models.CharField(max_length=400)
    npm = models.CharField(max_length=250)
    address = models.CharField(max_length=400, default=" ")
    mail_code = models.CharField(max_length=100, default=" ")
    hometown = models.CharField(max_length=250, default=" ")
    birthday = models.CharField(max_length=250, default=" ")
    program = models.CharField(max_length=250, default=" ")
    angkatan = models.CharField(max_length=250, default=" ")
    added_at = models.DateField(auto_now_add=True)

lab_7/views.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from django.urls import reverse
from django.views.decorators.csrf import csrf_exempt
from django.core import serializers
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger

from .models import Friend
from lab_9.csui_helper import get_mahasiswa_list, get_auth_param_dict
import os
import json
import math

response = {}

def index(request):
	# Page halaman menampilkan list mahasiswa yang ada
	# TODO berikan akses token dari backend dengan menggunakaan helper yang ada
	if 'user_login' in request.session:
		page = request.GET.get('page', 1) if int(request.GET.get('page', 1)) > 0 and int(request.GET.get('page', 1)) < 69 else 1

		mahasiswa_list = get_mahasiswa_list(request.session['access_token'], page)[0]
		total_page = math.ceil(get_mahasiswa_list(request.session['access_token'], page)[1]/100)
		friend_list = Friend.objects.all()
		auth = get_auth_param_dict(request.session['access_token'])

		response["mahasiswa_list"] = mahasiswa_list
		response["total_page"] = total_page
		response["friend_list"] = friend_list
		response["auth"] = auth
		response["page"] = page

		html = 'lab_7/lab_7.html'
		return render(request, html, response)
	else:
		html = 'lab_9/session/login.html'
		return render(request, html, response)

def friend_list(request):
	if 'user_login' in request.session:
		friend_list = Friend.objects.all()
		response['friend_list'] = friend_list
		html = 'lab_7/daftar_teman.html'
		return render(request, html, response)
	else:
		html = 'lab_9/session/login.html'
		return render(request, html, response)


def get_friend_list(request):
    if request.method == 'GET':
        friends = [obj.as_dict() for obj in Friend.objects.all()]
        return JsonResponse({"results": friends}, content_type='application/json')


@csrf_exempt
def add_friend(request):
    if request.method == 'POST':
        name = request.POST['name']
        npm = request.POST['npm']
        address = request.POST['address']
        mail_code = request.POST['mail_code']
        hometown = request.POST['hometown']
        birthday = request.POST['birthday']
        program = request.POST['program']
        angkatan = request.POST['angkatan']
        connect = Friend.objects.filter(npm = npm).exists()
        if(not connect):
            friend = Friend(friend_name=name,npm=npm,address=address,mail_code=mail_code,hometown=hometown,birthday=birthday,program=program,angkatan=angkatan)
            friend.save()
        data = model_to_dict(friend)
        return HttpResponse(data)


def delete_friend(request, npm):
    Friend.objects.filter(npm=npm).delete()
    return HttpResponseRedirect('/lab-7/friend-list/')

def friend_information(request, npm):
	friend = Friend.objects.filter(npm=npm)[0]
	response['friend'] = friend
	html = 'lab_7/info.html'
	return render(request, html, response)

@csrf_exempt
def validate_npm(request):
    npm = request.POST.get('npm', None)
    data = {
         'is_taken': Friend.objects.filter(npm = npm).exists()
    }
    return JsonResponse(data)

def model_to_dict(obj):
    data = serializers.serialize('json', [obj,])
    struct = json.loads(data)
    data = json.dumps(struct[0]["fields"])
    return data

lab_7/templates/lab_7/daftar_teman.html
{% extends "lab_7/layout/base.html" %}

{% block content %}
    <section name="friend-list" id="friend-list">
        <div class="container">
            <div class="row">
                <div class="col-md-8 col-lg-8">
                    <h2> Fasilkom's Friends</h2>
                    <div id="friend-list" class="list-group">

                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}
{% block javascript %}
    <script>
        $( document ).ready(function () {
            $.ajax({
                method: "GET",
                url: '{% url "lab-7:get-friend-list" %}',
                success: function (friend_list) {
                    var friends = JSON.parse(friend_list);
                    if(friends.length == 0){
                    
                        var html = '<div class="alert alert-danger text-center">\
                                <strong>Opps!</strong> Tidak ada mahasiswa \
                            </div>';
                        $("#friend-list").append(html)
                    }else{
                        var counter = 0;
                        $.each(friends,function(index,friend){
                            var button = '<span class="pull-right">'+
                                            '<button type="button" class="btn btn-xs btn-danger"'+
                                            'onClick="deleteFriend('+friend.fields.npm+')">'+
                                                '&times;'+
                                            '</button>'+
                                         '</span>';
                            var info = '<span class="col-xs-2 col-md-1 pull-right">'+
                                            '<button type="button" class="btn btn-xs btn-default btn-block"'+
                                            'onClick="description('+friend.fields.npm+')">'+
                                                'info'+
                                            '</button>'+
                                         '</span>';
                            
                            var html;

                            if(counter % 2 == 0){
                                html = '<a class="list-group-item list-group-item-warning text-center">'+
                                            friend.fields.friend_name +
                                            ' (' + friend.fields.npm + ')' + button + info + '</a>';
                            }else if(counter % 2 == 1){
                                html = '<a class="list-group-item list-group-item-info text-center">'+
                                            friend.fields.friend_name +
                                            ' (' + friend.fields.npm + ')' + button + info + '</a>';
                            }

                            $("#friend-list").append(html)
                            
                            counter += 1;
                        })
                    }
                },
                error: function(error){
                    alert("Terjadi kesalahan");
                }
            });
        });

        function deleteFriend(npm){
            window.open('delete-friend/'+npm+'/', '_self');
        }

        function description(npm){
            window.open('info/'+npm+'/', '_self');
        }
    </script>
{% endblock %}

lab_7/templates/lab_7/info.html
{% extends "lab_7/layout/base.html" %}

{% block content %}
<section name="friend-list" class="friend-list">
    <div class="container">
        <div class="row">
        	<div class="col-md-8 col-lg-12">
        		<h2>{{ friend.friend_name }} </h2>
        	</div>
            <div class="col-md-8 col-lg-12">
                <table width="100%">
	                <tr>
	                	<td><h4>NPM</h4></td>
	                	<td><h4>{{ friend.npm }}</h4></td>
	                </tr>
	                <tr>
	                	<td><h4>Alamat</h4></td>
	                	<td><h4  id="address">{{ friend.address }}</h4></td>
	                </tr>
	                <tr>
	                	<td><h4>Kode Pos</h4>
	                	<td><h4>{{ friend.mail_code }}</h4></td>
	                </tr>
	                <tr>
	                	<td><h4>Tempat Lahir</h4></td>
	                	<td><h4>{{ friend.hometown }}</h4></td>
                    </tr>
                    <tr>
	                	<td><h4>Tanggal Lahir</h4></td>
	                	<td><h4>{{ friend.birthday }}</h4></td>
                    </tr>
                    <tr>
	                	<td><h4>Program Studi</h4></td>
	                	<td><h4>{{ friend.program }}</h4></td>
                    </tr>
                    <tr>
	                	<td><h4>Angkatan</h4></td>
	                	<td><h4>{{ friend.angkatan }}</h4></td>
            		</tr>
            	</table>
            </div>
        </div>
    </div>
    <div class="container">
    	<div id="googleMap" style="width:1000px; height:500px; margin: 50px 0"></div>
    </div>
    <div>
    </div>
</section>
{% endblock %}
{% block javascript %}
<script>
	console.log($("#address").text());
	var address = $("#address").text();
	
	function initMap() {
		var geocoder = new google.maps.Geocoder();
		var infowindow = new google.maps.InfoWindow();
		geocoder.geocode({'address': address}, function(results, status) {
			if (status === google.maps.GeocoderStatus.OK) {
				var propertiPeta = {
					center: results[0].geometry.location,
					zoom: 16,
					mapTypeId: google.maps.MapTypeId.HYBRID
				};
				var peta = new google.maps.Map(document.getElementById("googleMap"), propertiPeta);
				var marker = new google.maps.Marker({
				  map: peta,
				  position: results[0].geometry.location
				  
				});

				google.maps.event.addListener(marker, 'click', function() {
              	infowindow.setContent('<div><strong>' + results[0].formatted_address + '</strong><br>' +
                '</div>');
              	infowindow.open(peta, this);
            });
			} else {
				var html = '<div class="alert alert-danger text-center">\
                            	Lokasi tidak ditemukan!\
                            </div>';
                $("#googleMap").append(html)
			}
		});
	}
</script>
{% endblock %}

lab_7/templates/lab_7/lab_7.html
{% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2 style="float: left"> Mahasiswa Fasilkom</h2>
                <ul class="pagination" style="float: right">
                    <li><a href="?page={{ page|add:-1 }}" id="to-prev">&laquo;</a></li>
                    <li><span id="pageof">Page {{ page }} of {{ total_page }}</span></li>
                    <li><a href="?page={{ page|add:1 }}" id="to-next">&raquo;</a></li>
                </ul>
                <br style="clear:both;" />
                <div class="list-group" id="list-mahasiswa">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                                    <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}', '{{ mahasiswa.alamat_mhs }}', '{{ mahasiswa.kota_lahir }}, {{ mahasiswa.tgl_lahir }}', '{{ mahasiswa.program.0.nm_org }} ({{ mahasiswa.program.0.nm_prg }})')">
                                        Tambah sebagai teman
                                    </span>
                                </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                </div>
                <ul class="pagination" style="float: right">
                    <li><a href="?page={{ page|add:-1 }}" id="to-prev">&laquo;</a></li>
                    <li><span id="pageof">Page {{ page }} of {{ total_page }}</span></li>
                    <li><a href="?page={{ page|add:1 }}" id="to-next">&raquo;</a></li>
                </ul>
                {% if auth %}
                    <div id="token" hidden="true">{{ auth.access_token }}</div>
                    <div id="cid" hidden="true">{{ auth.client_id }}</div>
                {% endif %}
            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">NPM:</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">Name:</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
                <a href="{% url 'lab-9:auth_logout' %}" class="btn btn-danger btn-block" onclick="return confirm('Keluar?')">
                      Logout </a>
            </div>
        </div>
    </div>
</section>
{% endblock %}


{% block javascript %}
<script>
    var token = document.getElementById("token").innerHTML;
    var cid = document.getElementById("cid").innerHTML;
    var addFriend = function(nama,npm,address,mail_code,hometown,birthday,program,angkatan) {
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:add-friend" %}',
            data: {
                name: nama,
                npm: npm,
                address: address,
                mail_code: mail_code,
                hometown: hometown,
                birthday: birthday,
                program: program,
                angkatan: angkatan,
            },
            success : function (friend) {
                html = '<a class="list-group-item clearfix">' +
                    friend.friend_name +
                    '</a>';
                $("#friend-list").append(html);
                window.location.reload();
            },
            error : function (error) {
                alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
            }
        });
    };

    $("#add-friend").on("submit", function (event) {
        var npm = $("#field_npm").val();
        var corsProxy = 'https://cors-anywhere.herokuapp.com/';
        var obj = new Object(); obj.access_token = token; obj.client_id = cid;
        var param = $.param(obj);
        $.ajax({
            method: "GET",
            url: corsProxy+'https://api-dev.cs.ui.ac.id/siakngcs/mahasiswa/'+npm+'/?'+param,
            success: function(data) {
                addFriend(data.nama, data.npm, data.alamat_mhs,data.kd_pos_mhs,
                          data.kota_lahir,data.tgl_lahir,
                          data.program[0].nm_org,data.program[0].nm_prg)
            },
            error: function(error) {
                console.log(error)
                alert("\n\t\t\tNPM tidak valid:\n\n'Tidak ada mahasiswa dengan NPM tersebut'")
            }
        });
        event.preventDefault();
    });



    $("#field_npm").change(function () {
        console.log( $(this).val() );
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                console.log(data)
                if (data.is_taken) {
                    alert("Mahasiswa dengan npm seperti ini sudah ada");
                }
            }
        });
    });
</script>

{% endblock %}